' To do:
' set pin numbers.
' set API version (probably 3)

'CONST Controllers.API.DJI7.Version = ?
'DJI7 digital joystick interface API.

' Controllers
' initial support for:
' digital joystick only
' two joysticks
' direct switch-pin connection on

' Pins for direct switch 

CONST Control.Up=1
CONST Control.Down=2
CONST Control.Left=3
CONST Control.Right=4
CONST Control.ButtonA=5
CONST Control.ButtonB=6
CONST Control.ButtonC=7
CONST Control.ButtonD=8

CONST Control.Max=8

CONST Controllers.MaxPlayers = 2
DIM Control.Pins(Controllers.MaxPlayers,Control.Max)

Control.Pins(1, Control.Up) = 35 ' digital up - pin 35
Control.Pins(1, Control.Down) = 36 ' digital down - pin 36
Control.Pins(1, Control.Left) = 38 ' digital left - pin 38
Control.Pins(1, Control.Right) = 29 ' digital right - pin 29

Control.Pins(1, Control.ButtonA) = 32 ' Button A - pin 32
Control.Pins(1, Control.ButtonB) = 33 ' Button B - pin 33

'Control.Pins(1, Control.ButtonC) = 
'Control.Pins(1, Control.ButtonD) = 

'Control.Pins(2, Control.Up) = 35 ' digital up - pin 
'Control.Pins(2, Control.Down) = 36 ' digital down - pin 
'Control.Pins(2, Control.Left) = 38 ' digital left - pin 
'Control.Pins(2, Control.Right) = 29 ' digital right - pin 

Control.Pins(2, Control.ButtonA) = Control.Pins(1, Control.ButtonC)
Control.Pins(2, Control.ButtonB) = Control.Pins(1, Control.ButtonD)



SUB Pins.InitDigital p
  ' Set pin number p as digital input, with pullup.
  SetPin p, din, pullup
END SUB

SUB Controllers.Init players
  ' default argument for players is interpreted as 1 player
  if players=0 then players=1

  if players > 2 then print "3 players not supported"

  local n
  for n=1 to players
    Pins.InitDigital Control.Pins(n, Control.Up)
    Pins.InitDigital Control.Pins(n, Control.Down)
    Pins.InitDigital Control.Pins(n, Control.Left)
    Pins.InitDigital Control.Pins(n, Control.Right)
    Pins.InitDigital Control.Pins(n, Control.ButtonA)
    Pins.InitDigital Control.Pins(n, Control.ButtonB)
  next
  if players = 1 then
    Pins.InitDigital Control.Pins(1, Control.ButtonC)
    Pins.InitDigital Control.Pins(1, Control.ButtonD)
  end if

END SUB

FUNCTION Control.Pins.Check(player,control)
  if player > Controllers.MaxPlayers then
    Control.Pins.Check = 0
  else
    ' Pins are low (0) for active
    Control.Pins.Check = pin(Control.Pins(player, control) = 0)
  end if
END FUNCTION

FUNCTION Controllers.Up(player)
  ' Pins are low (0) for active
  Controllers.Up = Control.Pins.Check(player, Control.Up)
END FUNCTION

FUNCTION Controllers.Down(player)

  ' Pins are low (0) for active
  Controllers.Down = Control.Pins.Check(player, Control.Down)

END FUNCTION

FUNCTION Controllers.Left(player)
  ' Pins are low (0) for active
  Controllers.Left = Control.Pins.Check(player, Control.Left)

END FUNCTION

FUNCTION Controllers.Right(player)
  ' Pins are low (0) for active
  Controllers.Right = Control.Pins.Check(player, Control.Right)

END FUNCTION

FUNCTION Controllers.ButtonA(player)
  ' Pins are low (0) for active
  Controllers.ButtonA = Control.Pins.Check(player, Control.ButtonA)

END FUNCTION

FUNCTION Controllers.ButtonB(player)
  ' Pins are low (0) for active
  Controllers.ButtonB = Control.Pins.Check(player, Control.ButtonB)

END FUNCTION

FUNCTION Controllers.ButtonC(player)
  ' Pins are low (0) for active
  Controllers.ButtonC = Control.Pins.Check(player, Control.ButtonC)

END FUNCTION

FUNCTION Controllers.ButtonD(player)
  ' Pins are low (0) for active
  Controllers.ButtonD = Control.Pins.Check(player, Control.ButtonD)

END FUNCTION



