
' Controllers
' alternative version, support for:
' terminal using inkey$
' converting to usb for testing multiplayer support

' this won't be as good as
' custom game code for USB keyboard (which might support key remapping,
' and displaying what the controls are)
' but you can use it for testing

CONST Controllers.API.DJI7.Version = 2
'DJI7 digital joystick interface API.
'API version 2 - supports checking controls by player number

CONST Keys.Up = "w"
CONST Keys.Down = "s"
CONST Keys.Left = "a"
CONST Keys.Right = "d"

CONST Keys.ButtonA = "c"
CONST Keys.ButtonB = "v"

CONST Keys.P2.Up = "i"
CONST Keys.P2.Down = "k"
CONST Keys.P2.Left = "j"
CONST Keys.P2.Right = "l"

CONST Keys.P2.ButtonA = "o" ' letter o
CONST Keys.P2.ButtonB = "0" ' number 0

FUNCTION Keys.RequestKey(k$)
  LOCAL i = asc(k$)
  LOCAL found = 0
  FOR j=1 TO KeyDown(0)
    if keydown(j)=i THEN found=1
  NEXT j
  Keys.RequestKey=found
END FUNCTION

SUB Controllers.Init players
  ' default argument for players is interpreted as 1 player

  if players > 2 then print "3 players not supported yet"

END SUB

FUNCTION Controllers.Up(player)
  IF player=2 THEN
    Controllers.Up = Keys.RequestKey(Keys.P2.Up)
  ELSE
    Controllers.Up = Keys.RequestKey(Keys.Up)
  ENDIF
END FUNCTION

FUNCTION Controllers.Down(player)

  IF player=2 THEN
    Controllers.Down = Keys.RequestKey(Keys.P2.Down)
  ELSE
    Controllers.Down = Keys.RequestKey(Keys.Down)
  ENDIF
END FUNCTION

FUNCTION Controllers.Left(player)

  IF player=2 THEN
    Controllers.Left = Keys.RequestKey(Keys.P2.Left)
  ELSE
    Controllers.Left = Keys.RequestKey(Keys.Left)
  ENDIF
END FUNCTION

FUNCTION Controllers.Right(player)

  IF player=2 THEN
    Controllers.Right = Keys.RequestKey(Keys.P2.Right)
  ELSE
    Controllers.Right = Keys.RequestKey(Keys.Right)
  ENDIF
END FUNCTION

FUNCTION Controllers.ButtonA(player)

  IF player=2 THEN
    Controllers.ButtonA = Keys.RequestKey(Keys.P2.ButtonA)
  ELSE
    Controllers.ButtonA = Keys.RequestKey(Keys.ButtonA)
  ENDIF
END FUNCTION

FUNCTION Controllers.ButtonB(player)

  IF player=2 THEN
    Controllers.ButtonB = Keys.RequestKey(Keys.P2.ButtonB)
  ELSE
    Controllers.ButtonB = Keys.RequestKey(Keys.ButtonB)
  ENDIF
END FUNCTION

